#include "winfishguts.h"
#include <stdlib.h>
#include <sys/types.h>
#include <stdio.h>
//#include <errno.h>

#include <string.h>
#include "echo-protocol.h"

/*
 * Forward a frame randomly.
 */
void forward(struct packet* p_pkt, int length) 
{
  fish_send(ANY_NEIGHBOR, p_pkt, length);
}

void send_packet( struct packet* p_pkt, int length) 
{
  forward(p_pkt, length);
}

/*
 * If the text is a send command, sends the echo packet and returns true.
 */
int echo_input(char* text) 
{
	int dst;
	char msg[ 256 ];
	struct packet pkt;

	if (2 != sscanf(text, "send %i %256s[^\n]", &dst, &msg)) 
	{
		return FALSE;
	}

	pkt.hdr.src = fish_getaddress();
	pkt.hdr.dst = dst;
	pkt.hdr.ttl = MAX_TTL;
	pkt.hdr.protocol = FISH_PROTOCOL_ECHO_REQUEST;
	strncpy(pkt.data, msg, PACKET_DATA_SIZE);
	pkt.data[PACKET_DATA_SIZE-1] = '\0';
	send_packet(&pkt, PACKET_HEADER_SIZE + strlen(pkt.data) + 1);

	return TRUE;
}

/*
 * Handle an echo request packet.
 */
void handle_echo_request( struct packet* p_pkt) 
{
  struct packet pkt;
  p_pkt->data[PACKET_DATA_SIZE-1] = '\0';
  printf("Echo request from %i: %s\n", p_pkt->hdr.src, p_pkt->data);
  pkt.hdr.src = fish_getaddress();
  pkt.hdr.dst = p_pkt->hdr.src;
  pkt.hdr.ttl = MAX_TTL;
  pkt.hdr.protocol = FISH_PROTOCOL_ECHO_RESPONSE;
  strncpy(pkt.data, p_pkt->data, PACKET_DATA_SIZE);
  send_packet(&pkt, PACKET_HEADER_SIZE + strlen(pkt.data) + 1);
}

/*
 * Handle an echo response packet.
 */
void handle_echo_response( struct packet* p_pkt) 
{
  p_pkt->data[PACKET_DATA_SIZE-1] = '\0';
  printf("Echo response from %i: %s\n", p_pkt->hdr.src, p_pkt->data);

}
